import connexion
import six

from mowgli_maki_manager.models.error import Error  # noqa: E501
from mowgli_maki_manager.models.maki_command import MakiCommand  # noqa: E501
from mowgli_maki_manager import util

from subprocess import Popen,PIPE,STDOUT


def management_command_post(makiCommand):  # noqa: E501
    """execute DBMS specific management command

     # noqa: E501

    :param makiCommand: the Maki command object
    :type makiCommand: dict | bytes

    :rtype: None
    """
    if connexion.request.is_json:
        makiCommand = MakiCommand.from_dict(connexion.request.get_json())  # noqa: E501

        if makiCommand.blocking:
            print("Executing a blocking maki command:")   
            print(" ".join(makiCommand.command))   

            process = Popen(makiCommand.command, stderr=STDOUT,stdout=PIPE)
            std_output, std_error = process.communicate()

            print("Process finished with exit code: " + str(process.returncode))
            print("Process STD output: " + str(std_output))
            print("Process STD error: " + str(std_error))

        else:        
            print("Executing a non-blocking maki command...")
            print(" ".join(makiCommand.command))
            process = Popen(makiCommand.command, stderr=STDOUT,stdout=PIPE)
            
            print("Non-blocking process started, returning!")
    
    return 'Successfully executed Maki management command!'
