# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from mowgli_maki_manager.models.base_model_ import Model
from mowgli_maki_manager.models.database_config_property import DatabaseConfigProperty  # noqa: F401,E501
from mowgli_maki_manager import util


class DatabaseConfig(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, database_binding: str=None, endpoint_parameter_name: str=None, table_parameter_name: str=None, table_name: str=None, config_porperties: List[DatabaseConfigProperty]=None):  # noqa: E501
        """DatabaseConfig - a model defined in Swagger

        :param database_binding: The database_binding of this DatabaseConfig.  # noqa: E501
        :type database_binding: str
        :param endpoint_parameter_name: The endpoint_parameter_name of this DatabaseConfig.  # noqa: E501
        :type endpoint_parameter_name: str
        :param table_parameter_name: The table_parameter_name of this DatabaseConfig.  # noqa: E501
        :type table_parameter_name: str
        :param table_name: The table_name of this DatabaseConfig.  # noqa: E501
        :type table_name: str
        :param config_porperties: The config_porperties of this DatabaseConfig.  # noqa: E501
        :type config_porperties: List[DatabaseConfigProperty]
        """
        self.swagger_types = {
            'database_binding': str,
            'endpoint_parameter_name': str,
            'table_parameter_name': str,
            'table_name': str,
            'config_porperties': List[DatabaseConfigProperty]
        }

        self.attribute_map = {
            'database_binding': 'databaseBinding',
            'endpoint_parameter_name': 'endpointParameterName',
            'table_parameter_name': 'tableParameterName',
            'table_name': 'tableName',
            'config_porperties': 'configPorperties'
        }

        self._database_binding = database_binding
        self._endpoint_parameter_name = endpoint_parameter_name
        self._table_parameter_name = table_parameter_name
        self._table_name = table_name
        self._config_porperties = config_porperties

    @classmethod
    def from_dict(cls, dikt) -> 'DatabaseConfig':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The DatabaseConfig of this DatabaseConfig.  # noqa: E501
        :rtype: DatabaseConfig
        """
        return util.deserialize_model(dikt, cls)

    @property
    def database_binding(self) -> str:
        """Gets the database_binding of this DatabaseConfig.


        :return: The database_binding of this DatabaseConfig.
        :rtype: str
        """
        return self._database_binding

    @database_binding.setter
    def database_binding(self, database_binding: str):
        """Sets the database_binding of this DatabaseConfig.


        :param database_binding: The database_binding of this DatabaseConfig.
        :type database_binding: str
        """
        allowed_values = ["COUCHBASE", "COUCHBASE2", "RIAK", "CASSANDRA2", "COCKROACHDB", "VOLTDB"]  # noqa: E501
        if database_binding not in allowed_values:
            raise ValueError(
                "Invalid value for `database_binding` ({0}), must be one of {1}"
                .format(database_binding, allowed_values)
            )

        self._database_binding = database_binding

    @property
    def endpoint_parameter_name(self) -> str:
        """Gets the endpoint_parameter_name of this DatabaseConfig.

        the name of the endpoint parameter of the selected driver, e.g. couchbase.host  # noqa: E501

        :return: The endpoint_parameter_name of this DatabaseConfig.
        :rtype: str
        """
        return self._endpoint_parameter_name

    @endpoint_parameter_name.setter
    def endpoint_parameter_name(self, endpoint_parameter_name: str):
        """Sets the endpoint_parameter_name of this DatabaseConfig.

        the name of the endpoint parameter of the selected driver, e.g. couchbase.host  # noqa: E501

        :param endpoint_parameter_name: The endpoint_parameter_name of this DatabaseConfig.
        :type endpoint_parameter_name: str
        """

        self._endpoint_parameter_name = endpoint_parameter_name

    @property
    def table_parameter_name(self) -> str:
        """Gets the table_parameter_name of this DatabaseConfig.

        the name of the parameter to specify the table to use with YCSB, e.g. couchbase.bucket  # noqa: E501

        :return: The table_parameter_name of this DatabaseConfig.
        :rtype: str
        """
        return self._table_parameter_name

    @table_parameter_name.setter
    def table_parameter_name(self, table_parameter_name: str):
        """Sets the table_parameter_name of this DatabaseConfig.

        the name of the parameter to specify the table to use with YCSB, e.g. couchbase.bucket  # noqa: E501

        :param table_parameter_name: The table_parameter_name of this DatabaseConfig.
        :type table_parameter_name: str
        """

        self._table_parameter_name = table_parameter_name

    @property
    def table_name(self) -> str:
        """Gets the table_name of this DatabaseConfig.

        the table name to use with YCSB, e.g. ycsb  # noqa: E501

        :return: The table_name of this DatabaseConfig.
        :rtype: str
        """
        return self._table_name

    @table_name.setter
    def table_name(self, table_name: str):
        """Sets the table_name of this DatabaseConfig.

        the table name to use with YCSB, e.g. ycsb  # noqa: E501

        :param table_name: The table_name of this DatabaseConfig.
        :type table_name: str
        """

        self._table_name = table_name

    @property
    def config_porperties(self) -> List[DatabaseConfigProperty]:
        """Gets the config_porperties of this DatabaseConfig.


        :return: The config_porperties of this DatabaseConfig.
        :rtype: List[DatabaseConfigProperty]
        """
        return self._config_porperties

    @config_porperties.setter
    def config_porperties(self, config_porperties: List[DatabaseConfigProperty]):
        """Sets the config_porperties of this DatabaseConfig.


        :param config_porperties: The config_porperties of this DatabaseConfig.
        :type config_porperties: List[DatabaseConfigProperty]
        """

        self._config_porperties = config_porperties
