# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from mowgli_maki_manager.models.base_model_ import Model
from mowgli_maki_manager import util


class MeasurementConfig(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, interval: int=None, measurement_type: str='NONE'):  # noqa: E501
        """MeasurementConfig - a model defined in Swagger

        :param interval: The interval of this MeasurementConfig.  # noqa: E501
        :type interval: int
        :param measurement_type: The measurement_type of this MeasurementConfig.  # noqa: E501
        :type measurement_type: str
        """
        self.swagger_types = {
            'interval': int,
            'measurement_type': str
        }

        self.attribute_map = {
            'interval': 'interval',
            'measurement_type': 'measurementType'
        }

        self._interval = interval
        self._measurement_type = measurement_type

    @classmethod
    def from_dict(cls, dikt) -> 'MeasurementConfig':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The MeasurementConfig of this MeasurementConfig.  # noqa: E501
        :rtype: MeasurementConfig
        """
        return util.deserialize_model(dikt, cls)

    @property
    def interval(self) -> int:
        """Gets the interval of this MeasurementConfig.

        measurement interval for reporting timeseries data, default 10 seconds  # noqa: E501

        :return: The interval of this MeasurementConfig.
        :rtype: int
        """
        return self._interval

    @interval.setter
    def interval(self, interval: int):
        """Sets the interval of this MeasurementConfig.

        measurement interval for reporting timeseries data, default 10 seconds  # noqa: E501

        :param interval: The interval of this MeasurementConfig.
        :type interval: int
        """

        self._interval = interval

    @property
    def measurement_type(self) -> str:
        """Gets the measurement_type of this MeasurementConfig.


        :return: The measurement_type of this MeasurementConfig.
        :rtype: str
        """
        return self._measurement_type

    @measurement_type.setter
    def measurement_type(self, measurement_type: str):
        """Sets the measurement_type of this MeasurementConfig.


        :param measurement_type: The measurement_type of this MeasurementConfig.
        :type measurement_type: str
        """
        allowed_values = ["NONE", "TIMESERIES", "HISTOGRAM"]  # noqa: E501
        if measurement_type not in allowed_values:
            raise ValueError(
                "Invalid value for `measurement_type` ({0}), must be one of {1}"
                .format(measurement_type, allowed_values)
            )

        self._measurement_type = measurement_type
