# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from mowgli_maki_manager.models.base_model_ import Model
from mowgli_maki_manager.models.db_endpoints import DBEndpoints  # noqa: F401,E501
from mowgli_maki_manager.models.tpcc_workload_config import TPCCWorkloadConfig  # noqa: F401,E501
from mowgli_maki_manager import util


class TPCCWorkload(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, db_endpoints: DBEndpoints=None, tpcc_workload_config: TPCCWorkloadConfig=None):  # noqa: E501
        """TPCCWorkload - a model defined in Swagger

        :param db_endpoints: The db_endpoints of this TPCCWorkload.  # noqa: E501
        :type db_endpoints: DBEndpoints
        :param tpcc_workload_config: The tpcc_workload_config of this TPCCWorkload.  # noqa: E501
        :type tpcc_workload_config: TPCCWorkloadConfig
        """
        self.swagger_types = {
            'db_endpoints': DBEndpoints,
            'tpcc_workload_config': TPCCWorkloadConfig
        }

        self.attribute_map = {
            'db_endpoints': 'dbEndpoints',
            'tpcc_workload_config': 'tpccWorkloadConfig'
        }

        self._db_endpoints = db_endpoints
        self._tpcc_workload_config = tpcc_workload_config

    @classmethod
    def from_dict(cls, dikt) -> 'TPCCWorkload':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The TPCCWorkload of this TPCCWorkload.  # noqa: E501
        :rtype: TPCCWorkload
        """
        return util.deserialize_model(dikt, cls)

    @property
    def db_endpoints(self) -> DBEndpoints:
        """Gets the db_endpoints of this TPCCWorkload.


        :return: The db_endpoints of this TPCCWorkload.
        :rtype: DBEndpoints
        """
        return self._db_endpoints

    @db_endpoints.setter
    def db_endpoints(self, db_endpoints: DBEndpoints):
        """Sets the db_endpoints of this TPCCWorkload.


        :param db_endpoints: The db_endpoints of this TPCCWorkload.
        :type db_endpoints: DBEndpoints
        """

        self._db_endpoints = db_endpoints

    @property
    def tpcc_workload_config(self) -> TPCCWorkloadConfig:
        """Gets the tpcc_workload_config of this TPCCWorkload.


        :return: The tpcc_workload_config of this TPCCWorkload.
        :rtype: TPCCWorkloadConfig
        """
        return self._tpcc_workload_config

    @tpcc_workload_config.setter
    def tpcc_workload_config(self, tpcc_workload_config: TPCCWorkloadConfig):
        """Sets the tpcc_workload_config of this TPCCWorkload.


        :param tpcc_workload_config: The tpcc_workload_config of this TPCCWorkload.
        :type tpcc_workload_config: TPCCWorkloadConfig
        """

        self._tpcc_workload_config = tpcc_workload_config
