# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from mowgli_maki_manager.models.base_model_ import Model
from mowgli_maki_manager import util


class TPCCWorkloadConfig(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, active_warehouses: int=None, drop: bool=None, duration: int=None, expensive_checks: bool=None, histogram: str=None, init: bool=None, interleaved: bool=None, max_ops: int=None, max_rate: float=None, ops_mix: str=None, partition_affinity: int=None, partitions: int=None, ramp: int=None, scatter: bool=None, seed: int=None, serializable: bool=None, split: bool=None, tolerate_errors: bool=None, wait: bool=None, warehouses: int=None, workers: int=None, zones: str=None):  # noqa: E501
        """TPCCWorkloadConfig - a model defined in Swagger

        :param active_warehouses: The active_warehouses of this TPCCWorkloadConfig.  # noqa: E501
        :type active_warehouses: int
        :param drop: The drop of this TPCCWorkloadConfig.  # noqa: E501
        :type drop: bool
        :param duration: The duration of this TPCCWorkloadConfig.  # noqa: E501
        :type duration: int
        :param expensive_checks: The expensive_checks of this TPCCWorkloadConfig.  # noqa: E501
        :type expensive_checks: bool
        :param histogram: The histogram of this TPCCWorkloadConfig.  # noqa: E501
        :type histogram: str
        :param init: The init of this TPCCWorkloadConfig.  # noqa: E501
        :type init: bool
        :param interleaved: The interleaved of this TPCCWorkloadConfig.  # noqa: E501
        :type interleaved: bool
        :param max_ops: The max_ops of this TPCCWorkloadConfig.  # noqa: E501
        :type max_ops: int
        :param max_rate: The max_rate of this TPCCWorkloadConfig.  # noqa: E501
        :type max_rate: float
        :param ops_mix: The ops_mix of this TPCCWorkloadConfig.  # noqa: E501
        :type ops_mix: str
        :param partition_affinity: The partition_affinity of this TPCCWorkloadConfig.  # noqa: E501
        :type partition_affinity: int
        :param partitions: The partitions of this TPCCWorkloadConfig.  # noqa: E501
        :type partitions: int
        :param ramp: The ramp of this TPCCWorkloadConfig.  # noqa: E501
        :type ramp: int
        :param scatter: The scatter of this TPCCWorkloadConfig.  # noqa: E501
        :type scatter: bool
        :param seed: The seed of this TPCCWorkloadConfig.  # noqa: E501
        :type seed: int
        :param serializable: The serializable of this TPCCWorkloadConfig.  # noqa: E501
        :type serializable: bool
        :param split: The split of this TPCCWorkloadConfig.  # noqa: E501
        :type split: bool
        :param tolerate_errors: The tolerate_errors of this TPCCWorkloadConfig.  # noqa: E501
        :type tolerate_errors: bool
        :param wait: The wait of this TPCCWorkloadConfig.  # noqa: E501
        :type wait: bool
        :param warehouses: The warehouses of this TPCCWorkloadConfig.  # noqa: E501
        :type warehouses: int
        :param workers: The workers of this TPCCWorkloadConfig.  # noqa: E501
        :type workers: int
        :param zones: The zones of this TPCCWorkloadConfig.  # noqa: E501
        :type zones: str
        """
        self.swagger_types = {
            'active_warehouses': int,
            'drop': bool,
            'duration': int,
            'expensive_checks': bool,
            'histogram': str,
            'init': bool,
            'interleaved': bool,
            'max_ops': int,
            'max_rate': float,
            'ops_mix': str,
            'partition_affinity': int,
            'partitions': int,
            'ramp': int,
            'scatter': bool,
            'seed': int,
            'serializable': bool,
            'split': bool,
            'tolerate_errors': bool,
            'wait': bool,
            'warehouses': int,
            'workers': int,
            'zones': str
        }

        self.attribute_map = {
            'active_warehouses': 'activeWarehouses',
            'drop': 'drop',
            'duration': 'duration',
            'expensive_checks': 'expensiveChecks',
            'histogram': 'histogram',
            'init': 'init',
            'interleaved': 'interleaved',
            'max_ops': 'maxOps',
            'max_rate': 'maxRate',
            'ops_mix': 'opsMix',
            'partition_affinity': 'partitionAffinity',
            'partitions': 'partitions',
            'ramp': 'ramp',
            'scatter': 'scatter',
            'seed': 'seed',
            'serializable': 'serializable',
            'split': 'split',
            'tolerate_errors': 'tolerateErrors',
            'wait': 'wait',
            'warehouses': 'warehouses',
            'workers': 'workers',
            'zones': 'zones'
        }

        self._active_warehouses = active_warehouses
        self._drop = drop
        self._duration = duration
        self._expensive_checks = expensive_checks
        self._histogram = histogram
        self._init = init
        self._interleaved = interleaved
        self._max_ops = max_ops
        self._max_rate = max_rate
        self._ops_mix = ops_mix
        self._partition_affinity = partition_affinity
        self._partitions = partitions
        self._ramp = ramp
        self._scatter = scatter
        self._seed = seed
        self._serializable = serializable
        self._split = split
        self._tolerate_errors = tolerate_errors
        self._wait = wait
        self._warehouses = warehouses
        self._workers = workers
        self._zones = zones

    @classmethod
    def from_dict(cls, dikt) -> 'TPCCWorkloadConfig':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The TPCCWorkloadConfig of this TPCCWorkloadConfig.  # noqa: E501
        :rtype: TPCCWorkloadConfig
        """
        return util.deserialize_model(dikt, cls)

    @property
    def active_warehouses(self) -> int:
        """Gets the active_warehouses of this TPCCWorkloadConfig.

        Run the load generator against a specific number of warehouses. Defaults to --warehouses  # noqa: E501

        :return: The active_warehouses of this TPCCWorkloadConfig.
        :rtype: int
        """
        return self._active_warehouses

    @active_warehouses.setter
    def active_warehouses(self, active_warehouses: int):
        """Sets the active_warehouses of this TPCCWorkloadConfig.

        Run the load generator against a specific number of warehouses. Defaults to --warehouses  # noqa: E501

        :param active_warehouses: The active_warehouses of this TPCCWorkloadConfig.
        :type active_warehouses: int
        """

        self._active_warehouses = active_warehouses

    @property
    def drop(self) -> bool:
        """Gets the drop of this TPCCWorkloadConfig.

        Drop the existing database, if it exists (implies --init)  # noqa: E501

        :return: The drop of this TPCCWorkloadConfig.
        :rtype: bool
        """
        return self._drop

    @drop.setter
    def drop(self, drop: bool):
        """Sets the drop of this TPCCWorkloadConfig.

        Drop the existing database, if it exists (implies --init)  # noqa: E501

        :param drop: The drop of this TPCCWorkloadConfig.
        :type drop: bool
        """

        self._drop = drop

    @property
    def duration(self) -> int:
        """Gets the duration of this TPCCWorkloadConfig.

        The duration to run in seconds. If 0, run forever  # noqa: E501

        :return: The duration of this TPCCWorkloadConfig.
        :rtype: int
        """
        return self._duration

    @duration.setter
    def duration(self, duration: int):
        """Sets the duration of this TPCCWorkloadConfig.

        The duration to run in seconds. If 0, run forever  # noqa: E501

        :param duration: The duration of this TPCCWorkloadConfig.
        :type duration: int
        """

        self._duration = duration

    @property
    def expensive_checks(self) -> bool:
        """Gets the expensive_checks of this TPCCWorkloadConfig.

        Run expensive checks  # noqa: E501

        :return: The expensive_checks of this TPCCWorkloadConfig.
        :rtype: bool
        """
        return self._expensive_checks

    @expensive_checks.setter
    def expensive_checks(self, expensive_checks: bool):
        """Sets the expensive_checks of this TPCCWorkloadConfig.

        Run expensive checks  # noqa: E501

        :param expensive_checks: The expensive_checks of this TPCCWorkloadConfig.
        :type expensive_checks: bool
        """

        self._expensive_checks = expensive_checks

    @property
    def histogram(self) -> str:
        """Gets the histogram of this TPCCWorkloadConfig.

        File to write per-op incremental and cumulative histogram data.  # noqa: E501

        :return: The histogram of this TPCCWorkloadConfig.
        :rtype: str
        """
        return self._histogram

    @histogram.setter
    def histogram(self, histogram: str):
        """Sets the histogram of this TPCCWorkloadConfig.

        File to write per-op incremental and cumulative histogram data.  # noqa: E501

        :param histogram: The histogram of this TPCCWorkloadConfig.
        :type histogram: str
        """

        self._histogram = histogram

    @property
    def init(self) -> bool:
        """Gets the init of this TPCCWorkloadConfig.

        Automatically run init  # noqa: E501

        :return: The init of this TPCCWorkloadConfig.
        :rtype: bool
        """
        return self._init

    @init.setter
    def init(self, init: bool):
        """Sets the init of this TPCCWorkloadConfig.

        Automatically run init  # noqa: E501

        :param init: The init of this TPCCWorkloadConfig.
        :type init: bool
        """

        self._init = init

    @property
    def interleaved(self) -> bool:
        """Gets the interleaved of this TPCCWorkloadConfig.

        Use interleaved tables  # noqa: E501

        :return: The interleaved of this TPCCWorkloadConfig.
        :rtype: bool
        """
        return self._interleaved

    @interleaved.setter
    def interleaved(self, interleaved: bool):
        """Sets the interleaved of this TPCCWorkloadConfig.

        Use interleaved tables  # noqa: E501

        :param interleaved: The interleaved of this TPCCWorkloadConfig.
        :type interleaved: bool
        """

        self._interleaved = interleaved

    @property
    def max_ops(self) -> int:
        """Gets the max_ops of this TPCCWorkloadConfig.

        Maximum number of operations to run  # noqa: E501

        :return: The max_ops of this TPCCWorkloadConfig.
        :rtype: int
        """
        return self._max_ops

    @max_ops.setter
    def max_ops(self, max_ops: int):
        """Sets the max_ops of this TPCCWorkloadConfig.

        Maximum number of operations to run  # noqa: E501

        :param max_ops: The max_ops of this TPCCWorkloadConfig.
        :type max_ops: int
        """

        self._max_ops = max_ops

    @property
    def max_rate(self) -> float:
        """Gets the max_rate of this TPCCWorkloadConfig.

        Maximum frequency of operations (reads/writes). If 0, no limit.  # noqa: E501

        :return: The max_rate of this TPCCWorkloadConfig.
        :rtype: float
        """
        return self._max_rate

    @max_rate.setter
    def max_rate(self, max_rate: float):
        """Sets the max_rate of this TPCCWorkloadConfig.

        Maximum frequency of operations (reads/writes). If 0, no limit.  # noqa: E501

        :param max_rate: The max_rate of this TPCCWorkloadConfig.
        :type max_rate: float
        """

        self._max_rate = max_rate

    @property
    def ops_mix(self) -> str:
        """Gets the ops_mix of this TPCCWorkloadConfig.

        Weights for the transaction mix. The default matches the TPCC spec. (default \"newOrder=10,payment=10,orderStatus=1,delivery=1,stockLevel=1\")  # noqa: E501

        :return: The ops_mix of this TPCCWorkloadConfig.
        :rtype: str
        """
        return self._ops_mix

    @ops_mix.setter
    def ops_mix(self, ops_mix: str):
        """Sets the ops_mix of this TPCCWorkloadConfig.

        Weights for the transaction mix. The default matches the TPCC spec. (default \"newOrder=10,payment=10,orderStatus=1,delivery=1,stockLevel=1\")  # noqa: E501

        :param ops_mix: The ops_mix of this TPCCWorkloadConfig.
        :type ops_mix: str
        """

        self._ops_mix = ops_mix

    @property
    def partition_affinity(self) -> int:
        """Gets the partition_affinity of this TPCCWorkloadConfig.

        Run load generator against specific partition (requires partitions) (default -1)  # noqa: E501

        :return: The partition_affinity of this TPCCWorkloadConfig.
        :rtype: int
        """
        return self._partition_affinity

    @partition_affinity.setter
    def partition_affinity(self, partition_affinity: int):
        """Sets the partition_affinity of this TPCCWorkloadConfig.

        Run load generator against specific partition (requires partitions) (default -1)  # noqa: E501

        :param partition_affinity: The partition_affinity of this TPCCWorkloadConfig.
        :type partition_affinity: int
        """

        self._partition_affinity = partition_affinity

    @property
    def partitions(self) -> int:
        """Gets the partitions of this TPCCWorkloadConfig.

        Partition tables (requires split)  # noqa: E501

        :return: The partitions of this TPCCWorkloadConfig.
        :rtype: int
        """
        return self._partitions

    @partitions.setter
    def partitions(self, partitions: int):
        """Sets the partitions of this TPCCWorkloadConfig.

        Partition tables (requires split)  # noqa: E501

        :param partitions: The partitions of this TPCCWorkloadConfig.
        :type partitions: int
        """

        self._partitions = partitions

    @property
    def ramp(self) -> int:
        """Gets the ramp of this TPCCWorkloadConfig.

        The duration in seconds over which to ramp up load.  # noqa: E501

        :return: The ramp of this TPCCWorkloadConfig.
        :rtype: int
        """
        return self._ramp

    @ramp.setter
    def ramp(self, ramp: int):
        """Sets the ramp of this TPCCWorkloadConfig.

        The duration in seconds over which to ramp up load.  # noqa: E501

        :param ramp: The ramp of this TPCCWorkloadConfig.
        :type ramp: int
        """

        self._ramp = ramp

    @property
    def scatter(self) -> bool:
        """Gets the scatter of this TPCCWorkloadConfig.

        Scatter ranges  # noqa: E501

        :return: The scatter of this TPCCWorkloadConfig.
        :rtype: bool
        """
        return self._scatter

    @scatter.setter
    def scatter(self, scatter: bool):
        """Sets the scatter of this TPCCWorkloadConfig.

        Scatter ranges  # noqa: E501

        :param scatter: The scatter of this TPCCWorkloadConfig.
        :type scatter: bool
        """

        self._scatter = scatter

    @property
    def seed(self) -> int:
        """Gets the seed of this TPCCWorkloadConfig.

        Random number generator seed (default 1)  # noqa: E501

        :return: The seed of this TPCCWorkloadConfig.
        :rtype: int
        """
        return self._seed

    @seed.setter
    def seed(self, seed: int):
        """Sets the seed of this TPCCWorkloadConfig.

        Random number generator seed (default 1)  # noqa: E501

        :param seed: The seed of this TPCCWorkloadConfig.
        :type seed: int
        """

        self._seed = seed

    @property
    def serializable(self) -> bool:
        """Gets the serializable of this TPCCWorkloadConfig.

        Force serializable mode  # noqa: E501

        :return: The serializable of this TPCCWorkloadConfig.
        :rtype: bool
        """
        return self._serializable

    @serializable.setter
    def serializable(self, serializable: bool):
        """Sets the serializable of this TPCCWorkloadConfig.

        Force serializable mode  # noqa: E501

        :param serializable: The serializable of this TPCCWorkloadConfig.
        :type serializable: bool
        """

        self._serializable = serializable

    @property
    def split(self) -> bool:
        """Gets the split of this TPCCWorkloadConfig.

        Split tables  # noqa: E501

        :return: The split of this TPCCWorkloadConfig.
        :rtype: bool
        """
        return self._split

    @split.setter
    def split(self, split: bool):
        """Sets the split of this TPCCWorkloadConfig.

        Split tables  # noqa: E501

        :param split: The split of this TPCCWorkloadConfig.
        :type split: bool
        """

        self._split = split

    @property
    def tolerate_errors(self) -> bool:
        """Gets the tolerate_errors of this TPCCWorkloadConfig.

        Keep running on error  # noqa: E501

        :return: The tolerate_errors of this TPCCWorkloadConfig.
        :rtype: bool
        """
        return self._tolerate_errors

    @tolerate_errors.setter
    def tolerate_errors(self, tolerate_errors: bool):
        """Sets the tolerate_errors of this TPCCWorkloadConfig.

        Keep running on error  # noqa: E501

        :param tolerate_errors: The tolerate_errors of this TPCCWorkloadConfig.
        :type tolerate_errors: bool
        """

        self._tolerate_errors = tolerate_errors

    @property
    def wait(self) -> bool:
        """Gets the wait of this TPCCWorkloadConfig.

        Run in wait mode (include think/keying sleeps) (default true)  # noqa: E501

        :return: The wait of this TPCCWorkloadConfig.
        :rtype: bool
        """
        return self._wait

    @wait.setter
    def wait(self, wait: bool):
        """Sets the wait of this TPCCWorkloadConfig.

        Run in wait mode (include think/keying sleeps) (default true)  # noqa: E501

        :param wait: The wait of this TPCCWorkloadConfig.
        :type wait: bool
        """

        self._wait = wait

    @property
    def warehouses(self) -> int:
        """Gets the warehouses of this TPCCWorkloadConfig.

        Number of warehouses for loading (default 1)  # noqa: E501

        :return: The warehouses of this TPCCWorkloadConfig.
        :rtype: int
        """
        return self._warehouses

    @warehouses.setter
    def warehouses(self, warehouses: int):
        """Sets the warehouses of this TPCCWorkloadConfig.

        Number of warehouses for loading (default 1)  # noqa: E501

        :param warehouses: The warehouses of this TPCCWorkloadConfig.
        :type warehouses: int
        """

        self._warehouses = warehouses

    @property
    def workers(self) -> int:
        """Gets the workers of this TPCCWorkloadConfig.

        Number of concurrent workers. Defaults to --warehouses * 10  # noqa: E501

        :return: The workers of this TPCCWorkloadConfig.
        :rtype: int
        """
        return self._workers

    @workers.setter
    def workers(self, workers: int):
        """Sets the workers of this TPCCWorkloadConfig.

        Number of concurrent workers. Defaults to --warehouses * 10  # noqa: E501

        :param workers: The workers of this TPCCWorkloadConfig.
        :type workers: int
        """

        self._workers = workers

    @property
    def zones(self) -> str:
        """Gets the zones of this TPCCWorkloadConfig.

        Zones for partitioning, the number of zones should match the number of partitions and the zones used to start cockroach.  # noqa: E501

        :return: The zones of this TPCCWorkloadConfig.
        :rtype: str
        """
        return self._zones

    @zones.setter
    def zones(self, zones: str):
        """Sets the zones of this TPCCWorkloadConfig.

        Zones for partitioning, the number of zones should match the number of partitions and the zones used to start cockroach.  # noqa: E501

        :param zones: The zones of this TPCCWorkloadConfig.
        :type zones: str
        """

        self._zones = zones
