# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from mowgli_maki_manager.models.base_model_ import Model
from mowgli_maki_manager import util


class WorkloadConfig(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, workload_type: str=None, workload_class: str='com.yahoo.ycsb.workloads.CoreWorkload', max_execution_time: int=None, thread_count: int=None, record_count: int=None, insert_start: int=None, insert_count: int=None, operations: int=None, target_ops: int=None, field_count: int=None, field_length: int=None, read_all_fileds: bool=True, read_modify_write_proportion: int=None, requestdistribution: str='UNIFORM', scan_length_distribution: str='UNIFORM', insert_order: str='ORDERED', read_proportion: float=0.95, update_proportion: float=0.05, insert_proportion: float=0.0, scan_proportion: float=0.0, max_scan_length: int=None, core_workload_insertion_retry_limit: int=None, core_workload_insertion_retry_interval: int=None):  # noqa: E501
        """WorkloadConfig - a model defined in Swagger

        :param workload_type: The workload_type of this WorkloadConfig.  # noqa: E501
        :type workload_type: str
        :param workload_class: The workload_class of this WorkloadConfig.  # noqa: E501
        :type workload_class: str
        :param max_execution_time: The max_execution_time of this WorkloadConfig.  # noqa: E501
        :type max_execution_time: int
        :param thread_count: The thread_count of this WorkloadConfig.  # noqa: E501
        :type thread_count: int
        :param record_count: The record_count of this WorkloadConfig.  # noqa: E501
        :type record_count: int
        :param insert_start: The insert_start of this WorkloadConfig.  # noqa: E501
        :type insert_start: int
        :param insert_count: The insert_count of this WorkloadConfig.  # noqa: E501
        :type insert_count: int
        :param operations: The operations of this WorkloadConfig.  # noqa: E501
        :type operations: int
        :param target_ops: The target_ops of this WorkloadConfig.  # noqa: E501
        :type target_ops: int
        :param field_count: The field_count of this WorkloadConfig.  # noqa: E501
        :type field_count: int
        :param field_length: The field_length of this WorkloadConfig.  # noqa: E501
        :type field_length: int
        :param read_all_fileds: The read_all_fileds of this WorkloadConfig.  # noqa: E501
        :type read_all_fileds: bool
        :param read_modify_write_proportion: The read_modify_write_proportion of this WorkloadConfig.  # noqa: E501
        :type read_modify_write_proportion: int
        :param requestdistribution: The requestdistribution of this WorkloadConfig.  # noqa: E501
        :type requestdistribution: str
        :param scan_length_distribution: The scan_length_distribution of this WorkloadConfig.  # noqa: E501
        :type scan_length_distribution: str
        :param insert_order: The insert_order of this WorkloadConfig.  # noqa: E501
        :type insert_order: str
        :param read_proportion: The read_proportion of this WorkloadConfig.  # noqa: E501
        :type read_proportion: float
        :param update_proportion: The update_proportion of this WorkloadConfig.  # noqa: E501
        :type update_proportion: float
        :param insert_proportion: The insert_proportion of this WorkloadConfig.  # noqa: E501
        :type insert_proportion: float
        :param scan_proportion: The scan_proportion of this WorkloadConfig.  # noqa: E501
        :type scan_proportion: float
        :param max_scan_length: The max_scan_length of this WorkloadConfig.  # noqa: E501
        :type max_scan_length: int
        :param core_workload_insertion_retry_limit: The core_workload_insertion_retry_limit of this WorkloadConfig.  # noqa: E501
        :type core_workload_insertion_retry_limit: int
        :param core_workload_insertion_retry_interval: The core_workload_insertion_retry_interval of this WorkloadConfig.  # noqa: E501
        :type core_workload_insertion_retry_interval: int
        """
        self.swagger_types = {
            'workload_type': str,
            'workload_class': str,
            'max_execution_time': int,
            'thread_count': int,
            'record_count': int,
            'insert_start': int,
            'insert_count': int,
            'operations': int,
            'target_ops': int,
            'field_count': int,
            'field_length': int,
            'read_all_fileds': bool,
            'read_modify_write_proportion': int,
            'requestdistribution': str,
            'scan_length_distribution': str,
            'insert_order': str,
            'read_proportion': float,
            'update_proportion': float,
            'insert_proportion': float,
            'scan_proportion': float,
            'max_scan_length': int,
            'core_workload_insertion_retry_limit': int,
            'core_workload_insertion_retry_interval': int
        }

        self.attribute_map = {
            'workload_type': 'workloadType',
            'workload_class': 'workloadClass',
            'max_execution_time': 'maxExecutionTime',
            'thread_count': 'threadCount',
            'record_count': 'recordCount',
            'insert_start': 'insertStart',
            'insert_count': 'insertCount',
            'operations': 'operations',
            'target_ops': 'targetOps',
            'field_count': 'fieldCount',
            'field_length': 'fieldLength',
            'read_all_fileds': 'readAllFileds',
            'read_modify_write_proportion': 'readModifyWriteProportion',
            'requestdistribution': 'requestdistribution',
            'scan_length_distribution': 'scanLengthDistribution',
            'insert_order': 'insertOrder',
            'read_proportion': 'readProportion',
            'update_proportion': 'updateProportion',
            'insert_proportion': 'insertProportion',
            'scan_proportion': 'scanProportion',
            'max_scan_length': 'maxScanLength',
            'core_workload_insertion_retry_limit': 'coreWorkloadInsertionRetryLimit',
            'core_workload_insertion_retry_interval': 'coreWorkloadInsertionRetryInterval'
        }

        self._workload_type = workload_type
        self._workload_class = workload_class
        self._max_execution_time = max_execution_time
        self._thread_count = thread_count
        self._record_count = record_count
        self._insert_start = insert_start
        self._insert_count = insert_count
        self._operations = operations
        self._target_ops = target_ops
        self._field_count = field_count
        self._field_length = field_length
        self._read_all_fileds = read_all_fileds
        self._read_modify_write_proportion = read_modify_write_proportion
        self._requestdistribution = requestdistribution
        self._scan_length_distribution = scan_length_distribution
        self._insert_order = insert_order
        self._read_proportion = read_proportion
        self._update_proportion = update_proportion
        self._insert_proportion = insert_proportion
        self._scan_proportion = scan_proportion
        self._max_scan_length = max_scan_length
        self._core_workload_insertion_retry_limit = core_workload_insertion_retry_limit
        self._core_workload_insertion_retry_interval = core_workload_insertion_retry_interval

    @classmethod
    def from_dict(cls, dikt) -> 'WorkloadConfig':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The WorkloadConfig of this WorkloadConfig.  # noqa: E501
        :rtype: WorkloadConfig
        """
        return util.deserialize_model(dikt, cls)

    @property
    def workload_type(self) -> str:
        """Gets the workload_type of this WorkloadConfig.


        :return: The workload_type of this WorkloadConfig.
        :rtype: str
        """
        return self._workload_type

    @workload_type.setter
    def workload_type(self, workload_type: str):
        """Sets the workload_type of this WorkloadConfig.


        :param workload_type: The workload_type of this WorkloadConfig.
        :type workload_type: str
        """
        allowed_values = ["LOAD", "RUN"]  # noqa: E501
        if workload_type not in allowed_values:
            raise ValueError(
                "Invalid value for `workload_type` ({0}), must be one of {1}"
                .format(workload_type, allowed_values)
            )

        self._workload_type = workload_type

    @property
    def workload_class(self) -> str:
        """Gets the workload_class of this WorkloadConfig.

        workload class, e.g. com.yahoo.ycsb.workloads.CoreWorkload  # noqa: E501

        :return: The workload_class of this WorkloadConfig.
        :rtype: str
        """
        return self._workload_class

    @workload_class.setter
    def workload_class(self, workload_class: str):
        """Sets the workload_class of this WorkloadConfig.

        workload class, e.g. com.yahoo.ycsb.workloads.CoreWorkload  # noqa: E501

        :param workload_class: The workload_class of this WorkloadConfig.
        :type workload_class: str
        """

        self._workload_class = workload_class

    @property
    def max_execution_time(self) -> int:
        """Gets the max_execution_time of this WorkloadConfig.

        maximal runtime in seconds, set 0 for unlimited  # noqa: E501

        :return: The max_execution_time of this WorkloadConfig.
        :rtype: int
        """
        return self._max_execution_time

    @max_execution_time.setter
    def max_execution_time(self, max_execution_time: int):
        """Sets the max_execution_time of this WorkloadConfig.

        maximal runtime in seconds, set 0 for unlimited  # noqa: E501

        :param max_execution_time: The max_execution_time of this WorkloadConfig.
        :type max_execution_time: int
        """

        self._max_execution_time = max_execution_time

    @property
    def thread_count(self) -> int:
        """Gets the thread_count of this WorkloadConfig.

        number of threads per client  # noqa: E501

        :return: The thread_count of this WorkloadConfig.
        :rtype: int
        """
        return self._thread_count

    @thread_count.setter
    def thread_count(self, thread_count: int):
        """Sets the thread_count of this WorkloadConfig.

        number of threads per client  # noqa: E501

        :param thread_count: The thread_count of this WorkloadConfig.
        :type thread_count: int
        """

        self._thread_count = thread_count

    @property
    def record_count(self) -> int:
        """Gets the record_count of this WorkloadConfig.

        number of records to load/operate on  # noqa: E501

        :return: The record_count of this WorkloadConfig.
        :rtype: int
        """
        return self._record_count

    @record_count.setter
    def record_count(self, record_count: int):
        """Sets the record_count of this WorkloadConfig.

        number of records to load/operate on  # noqa: E501

        :param record_count: The record_count of this WorkloadConfig.
        :type record_count: int
        """

        self._record_count = record_count

    @property
    def insert_start(self) -> int:
        """Gets the insert_start of this WorkloadConfig.

        only for parallel insert workloads, index to start with  # noqa: E501

        :return: The insert_start of this WorkloadConfig.
        :rtype: int
        """
        return self._insert_start

    @insert_start.setter
    def insert_start(self, insert_start: int):
        """Sets the insert_start of this WorkloadConfig.

        only for parallel insert workloads, index to start with  # noqa: E501

        :param insert_start: The insert_start of this WorkloadConfig.
        :type insert_start: int
        """

        self._insert_start = insert_start

    @property
    def insert_count(self) -> int:
        """Gets the insert_count of this WorkloadConfig.

        only for parallel insert workloads, total number of inserts by this client  # noqa: E501

        :return: The insert_count of this WorkloadConfig.
        :rtype: int
        """
        return self._insert_count

    @insert_count.setter
    def insert_count(self, insert_count: int):
        """Sets the insert_count of this WorkloadConfig.

        only for parallel insert workloads, total number of inserts by this client  # noqa: E501

        :param insert_count: The insert_count of this WorkloadConfig.
        :type insert_count: int
        """

        self._insert_count = insert_count

    @property
    def operations(self) -> int:
        """Gets the operations of this WorkloadConfig.

        total amount of operations to execute  # noqa: E501

        :return: The operations of this WorkloadConfig.
        :rtype: int
        """
        return self._operations

    @operations.setter
    def operations(self, operations: int):
        """Sets the operations of this WorkloadConfig.

        total amount of operations to execute  # noqa: E501

        :param operations: The operations of this WorkloadConfig.
        :type operations: int
        """

        self._operations = operations

    @property
    def target_ops(self) -> int:
        """Gets the target_ops of this WorkloadConfig.

        target operations per seconds per thread (if DB is able to execute)  # noqa: E501

        :return: The target_ops of this WorkloadConfig.
        :rtype: int
        """
        return self._target_ops

    @target_ops.setter
    def target_ops(self, target_ops: int):
        """Sets the target_ops of this WorkloadConfig.

        target operations per seconds per thread (if DB is able to execute)  # noqa: E501

        :param target_ops: The target_ops of this WorkloadConfig.
        :type target_ops: int
        """

        self._target_ops = target_ops

    @property
    def field_count(self) -> int:
        """Gets the field_count of this WorkloadConfig.

        he number of fields in a record  # noqa: E501

        :return: The field_count of this WorkloadConfig.
        :rtype: int
        """
        return self._field_count

    @field_count.setter
    def field_count(self, field_count: int):
        """Sets the field_count of this WorkloadConfig.

        he number of fields in a record  # noqa: E501

        :param field_count: The field_count of this WorkloadConfig.
        :type field_count: int
        """

        self._field_count = field_count

    @property
    def field_length(self) -> int:
        """Gets the field_length of this WorkloadConfig.

        the size of each field in Kb  # noqa: E501

        :return: The field_length of this WorkloadConfig.
        :rtype: int
        """
        return self._field_length

    @field_length.setter
    def field_length(self, field_length: int):
        """Sets the field_length of this WorkloadConfig.

        the size of each field in Kb  # noqa: E501

        :param field_length: The field_length of this WorkloadConfig.
        :type field_length: int
        """

        self._field_length = field_length

    @property
    def read_all_fileds(self) -> bool:
        """Gets the read_all_fileds of this WorkloadConfig.

        should reads read all fields (true) or just one (false)  # noqa: E501

        :return: The read_all_fileds of this WorkloadConfig.
        :rtype: bool
        """
        return self._read_all_fileds

    @read_all_fileds.setter
    def read_all_fileds(self, read_all_fileds: bool):
        """Sets the read_all_fileds of this WorkloadConfig.

        should reads read all fields (true) or just one (false)  # noqa: E501

        :param read_all_fileds: The read_all_fileds of this WorkloadConfig.
        :type read_all_fileds: bool
        """

        self._read_all_fileds = read_all_fileds

    @property
    def read_modify_write_proportion(self) -> int:
        """Gets the read_modify_write_proportion of this WorkloadConfig.

        what proportion of operations should be read a record, modify it, write it back  # noqa: E501

        :return: The read_modify_write_proportion of this WorkloadConfig.
        :rtype: int
        """
        return self._read_modify_write_proportion

    @read_modify_write_proportion.setter
    def read_modify_write_proportion(self, read_modify_write_proportion: int):
        """Sets the read_modify_write_proportion of this WorkloadConfig.

        what proportion of operations should be read a record, modify it, write it back  # noqa: E501

        :param read_modify_write_proportion: The read_modify_write_proportion of this WorkloadConfig.
        :type read_modify_write_proportion: int
        """

        self._read_modify_write_proportion = read_modify_write_proportion

    @property
    def requestdistribution(self) -> str:
        """Gets the requestdistribution of this WorkloadConfig.

        what distribution should be used to select the records to operate on – uniform, zipfian or latest  # noqa: E501

        :return: The requestdistribution of this WorkloadConfig.
        :rtype: str
        """
        return self._requestdistribution

    @requestdistribution.setter
    def requestdistribution(self, requestdistribution: str):
        """Sets the requestdistribution of this WorkloadConfig.

        what distribution should be used to select the records to operate on – uniform, zipfian or latest  # noqa: E501

        :param requestdistribution: The requestdistribution of this WorkloadConfig.
        :type requestdistribution: str
        """
        allowed_values = ["UNIFORM", "ZIPFIAN", "LATEST"]  # noqa: E501
        if requestdistribution not in allowed_values:
            raise ValueError(
                "Invalid value for `requestdistribution` ({0}), must be one of {1}"
                .format(requestdistribution, allowed_values)
            )

        self._requestdistribution = requestdistribution

    @property
    def scan_length_distribution(self) -> str:
        """Gets the scan_length_distribution of this WorkloadConfig.

        what distribution should be used to choose the number of records to scan, for each scan, between 1 and maxscanlength (default: uniform)  # noqa: E501

        :return: The scan_length_distribution of this WorkloadConfig.
        :rtype: str
        """
        return self._scan_length_distribution

    @scan_length_distribution.setter
    def scan_length_distribution(self, scan_length_distribution: str):
        """Sets the scan_length_distribution of this WorkloadConfig.

        what distribution should be used to choose the number of records to scan, for each scan, between 1 and maxscanlength (default: uniform)  # noqa: E501

        :param scan_length_distribution: The scan_length_distribution of this WorkloadConfig.
        :type scan_length_distribution: str
        """
        allowed_values = ["UNIFORM", "ZIPFIAN"]  # noqa: E501
        if scan_length_distribution not in allowed_values:
            raise ValueError(
                "Invalid value for `scan_length_distribution` ({0}), must be one of {1}"
                .format(scan_length_distribution, allowed_values)
            )

        self._scan_length_distribution = scan_length_distribution

    @property
    def insert_order(self) -> str:
        """Gets the insert_order of this WorkloadConfig.

        should records be inserted in order by key (“ordered”), or in hashed order (“hashed”)  # noqa: E501

        :return: The insert_order of this WorkloadConfig.
        :rtype: str
        """
        return self._insert_order

    @insert_order.setter
    def insert_order(self, insert_order: str):
        """Sets the insert_order of this WorkloadConfig.

        should records be inserted in order by key (“ordered”), or in hashed order (“hashed”)  # noqa: E501

        :param insert_order: The insert_order of this WorkloadConfig.
        :type insert_order: str
        """
        allowed_values = ["ORDERED", "HASHED"]  # noqa: E501
        if insert_order not in allowed_values:
            raise ValueError(
                "Invalid value for `insert_order` ({0}), must be one of {1}"
                .format(insert_order, allowed_values)
            )

        self._insert_order = insert_order

    @property
    def read_proportion(self) -> float:
        """Gets the read_proportion of this WorkloadConfig.

        proportion of operations should be reads  # noqa: E501

        :return: The read_proportion of this WorkloadConfig.
        :rtype: float
        """
        return self._read_proportion

    @read_proportion.setter
    def read_proportion(self, read_proportion: float):
        """Sets the read_proportion of this WorkloadConfig.

        proportion of operations should be reads  # noqa: E501

        :param read_proportion: The read_proportion of this WorkloadConfig.
        :type read_proportion: float
        """

        self._read_proportion = read_proportion

    @property
    def update_proportion(self) -> float:
        """Gets the update_proportion of this WorkloadConfig.

        proportion of operations should be updates  # noqa: E501

        :return: The update_proportion of this WorkloadConfig.
        :rtype: float
        """
        return self._update_proportion

    @update_proportion.setter
    def update_proportion(self, update_proportion: float):
        """Sets the update_proportion of this WorkloadConfig.

        proportion of operations should be updates  # noqa: E501

        :param update_proportion: The update_proportion of this WorkloadConfig.
        :type update_proportion: float
        """

        self._update_proportion = update_proportion

    @property
    def insert_proportion(self) -> float:
        """Gets the insert_proportion of this WorkloadConfig.

        proportion of operations should be inserts  # noqa: E501

        :return: The insert_proportion of this WorkloadConfig.
        :rtype: float
        """
        return self._insert_proportion

    @insert_proportion.setter
    def insert_proportion(self, insert_proportion: float):
        """Sets the insert_proportion of this WorkloadConfig.

        proportion of operations should be inserts  # noqa: E501

        :param insert_proportion: The insert_proportion of this WorkloadConfig.
        :type insert_proportion: float
        """

        self._insert_proportion = insert_proportion

    @property
    def scan_proportion(self) -> float:
        """Gets the scan_proportion of this WorkloadConfig.

        proportion of operations should be scans  # noqa: E501

        :return: The scan_proportion of this WorkloadConfig.
        :rtype: float
        """
        return self._scan_proportion

    @scan_proportion.setter
    def scan_proportion(self, scan_proportion: float):
        """Sets the scan_proportion of this WorkloadConfig.

        proportion of operations should be scans  # noqa: E501

        :param scan_proportion: The scan_proportion of this WorkloadConfig.
        :type scan_proportion: float
        """

        self._scan_proportion = scan_proportion

    @property
    def max_scan_length(self) -> int:
        """Gets the max_scan_length of this WorkloadConfig.

        for scans, what is the maximum number of records to scan (default 1000)  # noqa: E501

        :return: The max_scan_length of this WorkloadConfig.
        :rtype: int
        """
        return self._max_scan_length

    @max_scan_length.setter
    def max_scan_length(self, max_scan_length: int):
        """Sets the max_scan_length of this WorkloadConfig.

        for scans, what is the maximum number of records to scan (default 1000)  # noqa: E501

        :param max_scan_length: The max_scan_length of this WorkloadConfig.
        :type max_scan_length: int
        """

        self._max_scan_length = max_scan_length

    @property
    def core_workload_insertion_retry_limit(self) -> int:
        """Gets the core_workload_insertion_retry_limit of this WorkloadConfig.

        umber of attempts for any failed insert operation (default 0)  # noqa: E501

        :return: The core_workload_insertion_retry_limit of this WorkloadConfig.
        :rtype: int
        """
        return self._core_workload_insertion_retry_limit

    @core_workload_insertion_retry_limit.setter
    def core_workload_insertion_retry_limit(self, core_workload_insertion_retry_limit: int):
        """Sets the core_workload_insertion_retry_limit of this WorkloadConfig.

        umber of attempts for any failed insert operation (default 0)  # noqa: E501

        :param core_workload_insertion_retry_limit: The core_workload_insertion_retry_limit of this WorkloadConfig.
        :type core_workload_insertion_retry_limit: int
        """

        self._core_workload_insertion_retry_limit = core_workload_insertion_retry_limit

    @property
    def core_workload_insertion_retry_interval(self) -> int:
        """Gets the core_workload_insertion_retry_interval of this WorkloadConfig.

        interval between retries, in seconds (default 3)  # noqa: E501

        :return: The core_workload_insertion_retry_interval of this WorkloadConfig.
        :rtype: int
        """
        return self._core_workload_insertion_retry_interval

    @core_workload_insertion_retry_interval.setter
    def core_workload_insertion_retry_interval(self, core_workload_insertion_retry_interval: int):
        """Sets the core_workload_insertion_retry_interval of this WorkloadConfig.

        interval between retries, in seconds (default 3)  # noqa: E501

        :param core_workload_insertion_retry_interval: The core_workload_insertion_retry_interval of this WorkloadConfig.
        :type core_workload_insertion_retry_interval: int
        """

        self._core_workload_insertion_retry_interval = core_workload_insertion_retry_interval
