# coding: utf-8

from __future__ import absolute_import

from flask import json
from six import BytesIO

from mowgli_maki_manager.models.error import Error  # noqa: E501
from mowgli_maki_manager.models.tpcc_workload import TPCCWorkload  # noqa: E501
from mowgli_maki_manager.models.workload_process_instance import WorkloadProcessInstance  # noqa: E501
from mowgli_maki_manager.models.workload_process_submission_error import WorkloadProcessSubmissionError  # noqa: E501
from mowgli_maki_manager.models.ycsb_workload import YCSBWorkload  # noqa: E501
from mowgli_maki_manager.test import BaseTestCase


class TestDefaultController(BaseTestCase):
    """DefaultController integration test stubs"""

    def test_workload_result_get(self):
        """Test case for workload_result_get

        get the result file of a workload task
        """
        query_string = [('taskId', 'taskId_example'),
                        ('workloadType', 'workloadType_example')]
        response = self.client.open(
            '/v1/workload/result',
            method='GET',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_workload_status_get(self):
        """Test case for workload_status_get

        get the current state of the workloadProcess
        """
        query_string = [('applicationInstanceId', 'applicationInstanceId_example')]
        response = self.client.open(
            '/v1/workload/status',
            method='GET',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_workload_tpcc_post(self):
        """Test case for workload_tpcc_post

        starts a TPC-C workload against a relational DBMS
        """
        workload = TPCCWorkload()
        query_string = [('taskId', 'taskId_example')]
        response = self.client.open(
            '/v1/workload/tpcc',
            method='POST',
            data=json.dumps(workload),
            content_type='application/json',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_workload_ycsb_post(self):
        """Test case for workload_ycsb_post

        start a YCSB workload against the provided database
        """
        workload = YCSBWorkload()
        query_string = [('taskId', 'taskId_example')]
        response = self.client.open(
            '/v1/workload/ycsb',
            method='POST',
            data=json.dumps(workload),
            content_type='application/json',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))


if __name__ == '__main__':
    import unittest
    unittest.main()
